unit TaskCard1;
{
  **** Include Files ****

  A[JCoR|[lg for Delphi/C++Builder v1.44
  CMARC144.LZH
  
  NewOpen Dialog
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ImgList, ToolWin, ExtCtrls,
  IniFiles, Gigants, ARCHIVES;

type
  TTaskCardForm = class(TForm)
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    CheckBox2: TCheckBox;
    Label2: TLabel;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    OpenDialog1: TNewOpenDialog;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ArchiveFile1: TArchiveFile;
    procedure APLTerminateSwOn(Sender: TObject);
    procedure SaveSwOn(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileNameSelectSwON(Sender: TObject);
    procedure ExecuteON(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    JobResult : Integer;
    Function Exec(Owner: HWND): Boolean;
    Function DoArchive(SF: String; DF: String): Integer;
  end;

var
  TaskCardForm: TTaskCardForm;

implementation

{$R *.DFM}

procedure TTaskCardForm.APLTerminateSwOn(Sender: TObject);
begin
     if MessageDlg('Welcome to JOB CARD Dialog. Exit now?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
             Application.Terminate;
        end;
end;

procedure TTaskCardForm.SaveSwOn(Sender: TObject);
// Saved INI File
 var
    IniFile: TIniFile;
begin
    IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
    with IniFile do
    begin
         WriteInteger('System', 'JobKind', RadioGroup1.ItemIndex);
         WriteString('System', 'SourceFile', Edit1.Text);
         WriteString('System', 'DistFile', Edit2.Text);
         WriteBool('System', 'SourDelete', CheckBox1.Checked);
         WriteBool('System', 'OverWrite', CheckBox2.Checked);
    end;
    IniFile.Free;
//    if MessageDlg('Welcome to Time On Executer. Save to JOB Card?',
//       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
//       begin
//            ToolButton2Click(NIL);
//       end;
end;

procedure TTaskCardForm.FormCreate(Sender: TObject);
var
    IniFile   : TIniFile;
    i         : Integer;
    Menus_    : HMENU;
begin
     // Form̂w{^gpsɂ
     Menus_ := GetSystemMenu(TaskCardForm.Handle, False);
     DeleteMenu(Menus_, SC_CLOSE, MF_BYCOMMAND);
     DrawMenuBar(TaskCardForm.Handle);

    IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
    with IniFile do
    begin
         RadioGroup1.ItemIndex       := ReadInteger('System', 'JobKind', 0);
         Edit1.Text                  := ReadString('System', 'SourceFile', '');
         Edit2.Text                  := ReadString('System', 'DistFile', '');
         CheckBox1.Checked           := ReadBool('System', 'SourDelete', TRUE);
         CheckBox2.Checked           := ReadBool('System', 'OverWrite', TRUE);
    end;
    IniFile.Free;

    for i := 0 to ParamCount do
        begin
             //ShowMessage(ParamStr(i));
             if LowerCase(ParamStr(i)) = 'exec' then
                Begin
                     Hide;
                     Exec(Application.Handle);
                     //Application.Terminate;
                End Else
                Begin
                     if (LowerCase(ParamStr(i)) = 'exit') then
                        Begin
                             Application.Terminate;
                        End;
                End;
        End;
end;

procedure TTaskCardForm.FileNameSelectSwON(Sender: TObject);
begin
     If OpenDialog1.Execute Then
        Begin
             If Sender = Button1 Then
                Begin
                     Edit1.Text := OpenDialog1.FileName;
                End Else
                Begin
                     Edit2.Text := OpenDialog1.FileName;
                End;
        End;
end;

function TTaskCardForm.Exec(Owner: HWND): Boolean;
Var
   SL : TStringList;
//   Arc : TArchiveFile;
begin
     // Execution Procedure //
     Result := TRUE;
     If FileExists(Edit1.Text) Then
        Begin
             Case Radiogroup1.ItemIndex of
                  0: Begin // File Copy
                          SL := TStringList.Create;
                          IF  FileExists(Edit2.Text) Then
                             Begin
                                  If CheckBox2.Checked Then
                                     Begin
                                          Try
                                             SL.LoadFromFile(Edit1.Text);
                                             SL.SaveToFile(Edit2.Text);
                                             If CheckBox1.Checked Then DeleteFile(Edit1.Text);
                                          Except
                                                Result := FALSE;
                                          End;
                                     End Else
                                     Begin
                                          Result := FALSE;
                                     End;
                             End Else
                             Begin
                                  Try
                                     SL.LoadFromFile(Edit1.Text);
                                     SL.SaveToFile(Edit2.Text);
                                     If CheckBox1.Checked Then DeleteFile(Edit1.Text);
                                  Except
                                        Result := FALSE;
                                  End;
                             End;
                          SL.Free;
                     End;
                  1: Begin // File Compress
                           if -1 <> DoArchive(Edit1.Text, Edit2.Text) Then
                              Begin
                                   If CheckBox1.Checked Then // 폜ẘmF
                                      Begin
                                           DeleteFile(Edit1.Text);
                                      End Else
                                      Begin
                                           // 폜w͗L܂
                                      End;
                              End Else
                              Begin
                                   Result := FALSE; // kƂNG܂B
                              End;
                     End;
                  2: Begin // File Delete
                           Try
                              DeleteFile(Edit1.Text);
                           Except
                                 Result := FALSE;
                           End;
                     End;
             End;
        End Else
        Begin
             Result := FALSE;
        End;
end;

procedure TTaskCardForm.ExecuteON(Sender: TObject);
Var
   Source_ : String;
   Dist_   : String;
   Mes_    : String;
begin
     Source_ := ExtractFileName(Edit1.Text);
     Dist_   := ExtractFileName(Edit2.Text);
     Case Radiogroup1.ItemIndex of
          0: Begin
                  Mes_ := 'File Copy ' + Source_ +  ' to ' + Dist_;
             End;
          1: Begin
                  Mes_ := 'File Compres ' + Source_ +  ' to ' + Dist_;
             End;
          2: Begin
                  Mes_ := 'File Delete as ' + Source_;
             End;
     End;

     if MessageDlg('May I do the ' + Mes_ + '?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
             If Exec(Application.Handle) Then
                Begin
                     ShowMessage('Successful!');
                End Else
                Begin
                     ShowMessage('JOB failure');
                End;
        end;
end;
{
********************************************************************************
  kƁ@SF:kt@C@DF:k̃t@C
  Function͈kΏۂPɌ肵Ă܂BîƂj
  ߂ĎĝŃTvpĂ܂B
********************************************************************************
}
function TTaskCardForm.DoArchive(SF, DF: String): Integer;
var
	ArchiveFile : TArchiveFile;  // Ƀt@C
	FileList    : TStringList;   // t@CXg
	cond        : integer;       // RfBVȁHԒl
begin
//      Result := -1;
	//	k擯t@Cɂ폜Ă
	if FileExists( DF ) then DeleteFile( DF );
	ArchiveFile := TArchiveFile.Create( Self );
	FileList := TStringList.Create;

	try
		//	Ƀt@C̎w
		ArchiveFile.FileName := DF;  // gqw肵̂ŃA[JCo̎w͕sv
//		ArchiveFile.ArchiverType:= atLha;         // w肷ꍇ͂ȕɁB

		//	IvVw̗
		ArchiveFile.Options.x   := 1;             // fBNgL^  LHA  -x1 IvVɑ
//		ArchiveFile.Options.r   := 1;             // t@CċA  LHA  -r1 IvVɑ
		ArchiveFile.Options.jso := 1;             // LG[̏ꍇɏ𑱍s  LHA  -jso1 IvVɑ
		ArchiveFile.OutputSize  := 8192;          // o̓obt@TCYw

//		if not CheckBox1.Checked                  // oߔ\wȂH
//		then ArchiveFile.Options.n := 1;

//		if CheckBox2.Checked                      // o߃CxgLɂ
//		then ArchiveFile.OnProgress := ArchiveFileProgress;

		//	kt@C FileList ɓo^
		FileList.Add(SF);
//		FileList.Add( '*.PAS'    );
//		FileList.Add( '*.TXT'    );
//		FileList.Add( 'TEST\*.*' );

		//	t@Cks
//		if FALSE //	Ǝ_CAO\H
//		then begin
//			cond := dlgArchiverProgress.PackFiles( SF,nil,'',[FileList] );
//		end else begin
			cond := ArchiveFile.PackFiles( Handle,nil,'',[FileList] );
//		end;	// R߂̃IvV͊fBNg

		//	sʂ\
//		Edit1.Text := ArchiveFile.CmdLine;        // R}hC\
//		Edit2.Text := IntToHex( cond,4 );			//	߂l\
//		Memo1.Lines.SetText( PChar( ArchiveFile.Output ));
		Result := cond;														// o̓obt@̓e\
	finally
		ArchiveFile.Free;
		FileList.Free;
	end;
end;

end.
